CREATE OR REPLACE PROCEDURE IMPORTA_PEDIDO_AVIVA
IS
   -- PEDIDO
   V_PEDEXTERNO   VARCHAR2(15);
   V_DTENTPED     DATE;
   V_CDCLIENTE    VARCHAR2(20);
   V_DSPEDVEN     VARCHAR2(500);
   
   -- ITEMPEDIDO
   V_NRITEMPED       INTEGER;
   V_CDPRODEXTERNO   VARCHAR2(20);
   V_QTITEMPED       FLOAT;
   V_DTENTITPED      DATE;
   
   V_ERRO            VARCHAR2(500);
   
   V_CLIENTE      VARCHAR2(21);
   V_CDFILIAL     VARCHAR2(4);
   V_CDMODPGTO    VARCHAR2(5);
   V_CDVENDEDOR   VARCHAR2(4);
   V_CDTIPOOPER   VARCHAR2(2);
   V_CDPRECOBASE  VARCHAR2(2);
   V_CDFORMPGTO   VARCHAR2(2);
   V_CDPRODUTO    VARCHAR2(10);
   V_CDARVPROD    VARCHAR2(20);
   V_VRITEPREBASE FLOAT;
   V_CDOPERADOR   VARCHAR2(12);
   V_NRPEDIDO     VARCHAR2(20);
   V_NRITPED      VARCHAR2(10);
   V_NMPRODUTO    VARCHAR2(50);
   
   CURSOR C_PEDIDO IS
      SELECT I.PEDEXTERNO, I.DTENTPED, I.CDCLIENTE, I.DSPEDVEN
        FROM INT_PEDIDO_AVIVA I
       WHERE I.DTIMPORTACAO IS NULL
         AND I.LOG_ERRO IS NULL
         AND EXISTS (SELECT P.PEDEXTERNO
                       FROM INT_ITEMPED_AVIVA P
                      WHERE I.PEDEXTERNO = P.PEDEXTERNO);
   
   CURSOR C_ITEMPEDIDO(C_PEDEXTERNO IN VARCHAR2) IS
      SELECT NRITEMPED, CDPRODEXTERNO, QTITEMPED, DTENTITPED
        FROM INT_ITEMPED_AVIVA
       WHERE PEDEXTERNO = C_PEDEXTERNO
         AND DTIMPORTACAO IS NULL
       ORDER BY NRITEMPED;
BEGIN
   V_CDFILIAL := '9999';
   V_CDOPERADOR := '999999999999';
   
   OPEN C_PEDIDO;
   LOOP
      FETCH C_PEDIDO INTO V_PEDEXTERNO, V_DTENTPED, V_CDCLIENTE, V_DSPEDVEN;
      EXIT WHEN C_PEDIDO%NOTFOUND;
      
      BEGIN
         SELECT CDCLIENTE
           INTO V_CLIENTE
           FROM EXPORTCLIE
          WHERE CDCLIEEXPORT = V_CDCLIENTE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_ERRO := 'Cliente n'||CHR(227)||'o cadastrado';
      END;
      
      IF (V_CLIENTE IS NOT NULL) THEN
         BEGIN
            SELECT CDMODPGTO, CDVENDEDOR, CDTIPOOPER
              INTO V_CDMODPGTO, V_CDVENDEDOR, V_CDTIPOOPER
              FROM PARAMPEDIDO
             WHERE CDFILIAL = V_CDFILIAL;
         EXCEPTION
            WHEN OTHERS THEN
               V_ERRO := 'Parametriza'||CHR(231)||CHR(227)||'o da filial deve ser realizada';
         END;
         
         IF (V_CDMODPGTO IS NULL) THEN
            V_ERRO := 'Modalidade de pagamento n'||CHR(227)||'o parametrizada para a filial';
         END IF;
         
         IF (V_CDVENDEDOR IS NULL) THEN
            V_ERRO := 'Vendedor n'||CHR(227)||'o parametrizado para a filial';
         END IF;
         
         IF (V_CDTIPOOPER IS NULL) THEN
            V_ERRO := 'Tipo de operao n'||CHR(227)||'o parametrizado para a filial';
         END IF;      
         
         -- PREO BASE PADRAO
         BEGIN
            SELECT MIN(CDPRECOBASE) CDPRECOBASE
              INTO V_CDPRECOBASE
              FROM (SELECT PB.CDPRECOBASE
                      FROM PRECOBASE PB, PRECOBASECLI PC
                     WHERE PB.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
                                                FROM PRECOBASECLI
                                               WHERE CDCLIENTE = V_CLIENTE)
                       AND (PC.CDPRECOBASE  = PB.CDPRECOBASE)
                       AND (PC.CDCLIENTE    = V_CLIENTE)
                       AND (PC.IDPRBASEPRIN = 'S')
                     UNION
                    SELECT P.CDPRECOBASE
                      FROM PRECOBASE P, VENDEDOR V
                     WHERE (P.CDPRECOBASE = V.CDPRECOBASE)
                       AND (V.CDVENDEDOR  = V_CDVENDEDOR)
                       AND P.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
                                               FROM PRECOBASECLI
                                              WHERE CDCLIENTE = V_CLIENTE)
                      UNION
                     SELECT PB.CDPRECOBASE
                       FROM PRECOBASE PB, PRECOUTI PC
                      WHERE (PB.CDPRECOBASE = PC.CDPRECOBASE)
                        AND (PC.CDMODPGTO   = V_CDMODPGTO)
                        AND PB.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
                                                 FROM PRECOBASECLI
                                                 WHERE CDCLIENTE = V_CLIENTE));     
         EXCEPTION
            WHEN OTHERS THEN
               V_ERRO := SQLERRM(SQLCODE);
         END;
         
         IF (V_CDPRECOBASE IS NULL) THEN
            V_ERRO := 'Pre'||CHR(231)||'o base n'||CHR(227)||'o cadastrado';
         END IF;
      
         -- Se nao houver erros o processo continua. Os erros nao estao sendo concatenados por falta de espaco.
         IF (V_ERRO IS NULL) THEN
            SELECT CDFORMPGTO
              INTO V_CDFORMPGTO
              FROM MODPGTO
             WHERE CDMODPGTO = V_CDMODPGTO;
            
            NOVO_CODIGO_SC('PEDIDO'||V_CDFILIAL, V_NRPEDIDO, 1, NULL);
            V_NRPEDIDO := SUBSTR(V_NRPEDIDO, -10);
            
            -- IDPRIOPED = '3'
            -- IDSITPEDIDO = '1'
            -- IDPGFRETTRAN = '9' (Sem ocorrncia de transporte)
            -- IDUTDIAPAGPED = 'I'
            -- IDTIPOPEDIDO = '1'
            -- IDENTRSAIDOP = 'S'
            -- IDPEDINDUSTRIA = 'N'
            INSERT INTO PEDIDO(CDFILIAL, NRPEDIDO, CDCLIENTE, CDVENDEDOR, DTPEDIDO, DTENTPED, IDPRIOPED, DTHRLANPED, CDOPELANPED, IDSITPEDIDO,
                               IDPGFRETTRAN, CDMODPGTO, CDFORMPGTO, IDUTDIAPAGPED, IDTIPOPEDIDO, CDPRECOBASE, IDENTRSAIDOP, CDTIPOOPER, IDPEDINDUSTRIA)
            VALUES(V_CDFILIAL, V_NRPEDIDO, V_CLIENTE, V_CDVENDEDOR, V_DTENTPED, V_DTENTPED, '3', TO_CHAR(SYSDATE, 'DD/MM/YYYY'), V_CDOPERADOR, '1',
                   '9', V_CDMODPGTO, V_CDFORMPGTO, 'I', '1', V_CDPRECOBASE, 'S', V_CDTIPOOPER, 'N');            
            
            FOR C_PRAZO IN (SELECT NRDIASMODPGTO, VRPERCMODPGTO
                              FROM PRAZOMODPGTO
                             WHERE CDMODPGTO = V_CDMODPGTO) 
            LOOP
               INSERT INTO PRAZOPGTOPED(CDFILIAL, NRPEDIDO, NRDIASPGTOPED, VRPERCPGTOPED)
               VALUES(V_CDFILIAL, V_NRPEDIDO, C_PRAZO.NRDIASMODPGTO, C_PRAZO.VRPERCMODPGTO);
            END LOOP;
            
            INSERT INTO OBSPEDIDO(CDFILIAL, NRPEDIDO, TXOBSPED)
            VALUES(V_CDFILIAL, V_NRPEDIDO, UTL_RAW.CAST_TO_RAW(V_DSPEDVEN));
            
            OPEN C_ITEMPEDIDO(V_PEDEXTERNO);
            LOOP
               FETCH C_ITEMPEDIDO INTO V_NRITEMPED, V_CDPRODEXTERNO, V_QTITEMPED, V_DTENTITPED;
               EXIT WHEN C_ITEMPEDIDO%NOTFOUND;
               
               BEGIN
                  SELECT CDPRODUTO, CDARVPROD, NMPRODUTO
                    INTO V_CDPRODUTO, V_CDARVPROD, V_NMPRODUTO
                    FROM PRODUTO
                   WHERE CDPRODINTE = V_CDPRODEXTERNO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     ROLLBACK;
                     V_ERRO := 'Produto '||V_CDPRODEXTERNO||' n'||CHR(227)||'o cadastrado';
                     EXIT;
                  WHEN DUP_VAL_ON_INDEX THEN
                     ROLLBACK;
                     V_ERRO := 'Mais de um produto com o c'||CHR(243)||'digo '||V_CDPRODEXTERNO||' cadastrado.';
                     EXIT;
               END;
               
               BEGIN
                  SELECT VRITEPREBASE
                    INTO V_VRITEPREBASE
                    FROM ITEMPREBASE
                   WHERE CDPRECOBASE = V_CDPRECOBASE
                     AND CDPRODUTO = V_CDPRODUTO
                     AND V_DTENTITPED BETWEEN DTINIVALIPB AND NVL(DTFIMVALIPB, SYSDATE);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     ROLLBACK;
                     V_ERRO := 'O produto '||V_CDARVPROD||' - '||V_NMPRODUTO||' n'||CHR(227)||'o possui pre'||CHR(231)||'o cadastrado na tabela de pre'||CHR(231)||'o '||V_CDPRECOBASE;
                     EXIT;
               END;
               
               GRAVA_ITEMPEDIDO(P_CDFILIAL     => V_CDFILIAL, 
                                P_NRPEDIDO     => V_NRPEDIDO, 
                                P_CDPRODUTO    => V_CDPRODUTO, 
                                P_QTITEMPED    => V_QTITEMPED, 
                                P_VRPREUNITPED => V_VRITEPREBASE, 
                                P_CDFATPRECO   => NULL, 
                                P_VRDESITPED   => 0, 
                                P_VRPESOITPED  => NULL,
                                P_VRPRTABITPED => V_VRITEPREBASE,
                                P_VRPEDEMAXIPE => NULL, 
                                P_DTENTITPED   => V_DTENTITPED, 
                                P_DTENTPED     => V_DTENTITPED,
                                P_CDMENSERRO   => V_ERRO,     -- PARAMETRO DE SAIDA PRA ERROS
                                P_NRITEMPED    => V_NRITPED); -- PARAMETRO DE SAIDA PARA O NRITEMPED
               
               IF V_ERRO <> 'OK' THEN
                  ROLLBACK;
                  EXIT;
               ELSE
                  UPDATE ITEMPEDIDO
                     SET IDITPEDDIFER = 'N'
                   WHERE CDFILIAL  = V_CDFILIAL
                     AND NRPEDIDO  = V_NRPEDIDO
                     AND NRITEMPED = V_NRITPED;
                     
                  UPDATE INT_ITEMPED_AVIVA
                     SET DTIMPORTACAO = SYSDATE,
                         HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH24:MI')
                   WHERE PEDEXTERNO = V_PEDEXTERNO
                     AND NRITEMPED = V_NRITEMPED;
                  
                  V_ERRO := NULL;
               END IF;
            END LOOP;
            CLOSE C_ITEMPEDIDO;
            
            IF (V_ERRO IS NOT NULL) THEN
               ROLLBACK;
               
               UPDATE INT_ITEMPED_AVIVA
                  SET LOG_ERRO = V_ERRO
                WHERE PEDEXTERNO = V_PEDEXTERNO
                  AND NRITEMPED = V_NRITEMPED;
               
               COMMIT;
            END IF;
         END IF;
      END IF;      
      
      IF (V_ERRO IS NOT NULL) THEN
         ROLLBACK;
         
         UPDATE INT_PEDIDO_AVIVA
            SET LOG_ERRO = V_ERRO
          WHERE PEDEXTERNO = V_PEDEXTERNO;
         
         COMMIT;
      ELSE
         UPDATE INT_PEDIDO_AVIVA
            SET DTIMPORTACAO = SYSDATE,
                HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH24:MI')
          WHERE PEDEXTERNO = V_PEDEXTERNO;
         
         COMMIT;
      END IF;
   END LOOP;
   CLOSE C_PEDIDO;
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      V_ERRO := SQLERRM(SQLCODE);
      
      UPDATE INT_PEDIDO_AVIVA
         SET LOG_ERRO = V_ERRO
       WHERE PEDEXTERNO = V_PEDEXTERNO;
      
      COMMIT;
      IF C_PEDIDO%ISOPEN THEN
         CLOSE C_PEDIDO;
      END IF;
      
      IF C_ITEMPEDIDO%ISOPEN THEN
         CLOSE C_ITEMPEDIDO;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_PEDIDO_AVIVA','6.35.020'); END;
/
