function Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController(General, ScreenService, localStorageEngine, MessageService) {

    // var listaUnidades = '';
    // var listaComprador = '';
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function concatProdutoFinal(value) {
        const pad = 'ZZZZZZZZZZ';
        
        return value + pad.substr(0, pad.length - value.length);
    }
    
    this.initialValidations = function (widget) {
        widget.newRow();
        
        widget.applyDefaultValue();
        
        setReportValues(widget);
    };
    
    function setReportValues(widget) {
        const fieldUnidade = widget.getField("CDFILIAL");
        
        if (!widget.currentRow.NRORG) {
            widget.newRow();
        }
        
        fieldUnidade.setValue([getLocalVar('CDFILIAL')]);
        fieldUnidade.reload();
    }

    this.criaRelatorio = function(widget) {
        const reportName = widget.currentRow.CD_REPORT_NAME;
        
        if (widget.isValid() && this.validaProduto(widget.currentRow.CDARVPRODINI, widget.currentRow.CDARVPRODFIN)) {
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportName] );
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            return true;
        }
        MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
        return false;
    };
    
    this.abreRelatorio = function(widget, reportName) {
        const row = angular.copy(widget.currentRow);
        
        row.CDOPERADOR = concatArrayForParams(row.CDOPERADOR, "T");
        row.CDFILIAL = concatArrayForParams(row.CDFILIAL, "T");
        row.CDPRODFIN1 = row.CDARVPRODFIN;
        row.CDPRODFIN  = concatProdutoFinal(row.CDARVPRODFIN);
       
        General.openReport("cmp_relatorio#/cmp04800_relatorio", reportName, row);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController', Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController);
});